#pragma once

#include <QProgressBar>
#include "CProcessBase.h"

class QtGDALProcessBar : public QProgressBar,public CProcessBase
{
	Q_OBJECT

public:
	QtGDALProcessBar(QWidget *parent = Q_NULLPTR);
	~QtGDALProcessBar();

	/**
		* @brief ýϢ
		* @param pszMsg			Ϣ
		*/
	void SetMessage(const char* pszMsg);

	/**
	* @brief ýֵ
	* @param dPosition		ֵ
	*/
	bool SetPosition(double dPosition);

	/// <summary>
	/// ýʼֵ
	/// </summary>
	/// <param name="i_start_value"></param>
	/// <returns></returns>
	bool SetStartEndValue(int i_start_value,int i_end_value);


	/**
	* @brief ǰһ
	*/
	bool StepIt();

	/// <summary>
	/// ǰֵ
	/// </summary>
	int current_value;


public slots:
	void updateProgress(int);


private:
	/// <summary>
	/// ʼֵ
	/// </summary>
	int m_start_value;

	/// <summary>
	/// ֵ
	/// </summary>
	int m_end_value;

	float m_scale;

};
