#include "im2shp.h"
#include <ogrsf_frmts.h>
#include "CProcessBase.h"
/**
* \brief GDALӿ
*
* úڽGDAL㷨еĽϢCProcessBaseУʾ
*
* @param dfComplete	ɽֵȡֵΪ 0.0  1.0 ֮
* @param pszMessage	Ϣ
* @param pProgressArg   CProcessBaseָ
*
* @return TRUEʾ㣬Ϊȡ
*/
int STD_API ALGTermProgress(double dfComplete, const char* pszMessage, void* pProgressArg)
{
	if (pProgressArg != NULL)
	{
		QtGDALProcessBar* pProcess = (QtGDALProcessBar*)pProgressArg;
		pProcess->m_bIsContinue = pProcess->SetPosition(dfComplete);

		if (pProcess->m_bIsContinue)
			return TRUE;
		else
			return FALSE;
	}
	else
		return TRUE;
}


int img2shp::ImagePolygonize(const char* pszSrcFile, const char* pszDstFile, const char* pszFormat, int BandNum,
	QtGDALProcessBar* probar, QProgressBar* progressBar)
{
	if (NULL == pszSrcFile || NULL == pszDstFile)
	{
		printf("դݼʸЧ");
		return false;
	}

	if (GDALGetDriverCount() == 0)
		GDALAllRegister();
	OGRRegisterAll();
	CPLSetConfigOption("GDAL_FILENAME_IS_UTF8", "NO");
	CPLSetConfigOption("SHAPE_ENCODING", "gb2312");

	//ͼ񣬲жǷ
	GDALDataset* poSrcDS = (GDALDataset*)GDALOpen(pszSrcFile, GA_ReadOnly);
	if (NULL == poSrcDS)
	{
		printf("ļܴ򿪣ļǷڣ");
		return false;
	}

	//ʸļʸͼ
	GDALDriver* poDriver = GetGDALDriverManager()->GetDriverByName(pszFormat);
	if (NULL == poDriver)
	{
		printf("ָܴ͵ʸļ");
		GDALClose((GDALDatasetH)poSrcDS);
		return false;
	}


	/*
	*CreateҪڴդļݼnXSizenYSizenBandsǶդļ**̨Ĭϴʸݼ**
	*/
	//ļʸݼ

	GDALDataset* poDstDs = poDriver->Create(pszDstFile, 0, 0, 0, GDT_Unknown, NULL);
	if (NULL == poDstDs)
	{
		printf("ܴʸļ");
		GDALClose((GDALDatasetH)poSrcDS);

		return false;
	}

	OGRSpatialReference* poSpatialRef = new OGRSpatialReference(poSrcDS->GetProjectionRef());

	OGRLayer* poLayer = poDstDs->CreateLayer("Target", poSpatialRef, wkbPolygon, NULL);
	if (NULL == poLayer)
	{
		printf("ʸͼʧܣ");
		GDALClose((GDALDatasetH)poSrcDS);
		GDALClose(poDstDs);
		poSpatialRef = NULL;

		return false;
	}
	OGRFieldDefn ofieldDef("value", OFTInteger);
	if (OGRERR_NONE != poLayer->CreateField(&ofieldDef))
	{
		printf("ʸͼԱʧܣ");
		GDALClose((GDALDatasetH)poSrcDS);
		GDALClose(poDstDs);
		poSpatialRef = NULL;

		return false;
	}

	//ȡͼĶӦ
	GDALRasterBandH hSrcBand = (GDALRasterBandH)poSrcDS->GetRasterBand(1);

	GDALRasterBand* rasterband = poSrcDS->GetRasterBand(1);

	GDALProgressFunc pfnProgress = ALGTermProgress;

	if (!probar->SetStartEndValue(0, 100))
	{
		cout << "ʼֵʧܣ" << endl;
	}


	//if (GDALPolygonize(hSrcBand, NULL, (OGRLayerH)poLayer, 0, NULL, pfnProgress, probar) != CE_None)
	//if (GDALPolygonize(hSrcBand, NULL, (OGRLayerH)poLayer, 0, NULL, GDALTermProgress, NULL) != CE_None)
	//qDebug() << rasterband->GetNoDataValue() << endl;
	//if (0.0 == poSrcDS->GetRasterBand(1)->GetNoDataValue())
	//{
	//	if (CE_None != GDALPolygonize(hSrcBand, hSrcBand, (OGRLayerH)poLayer, 0, NULL, pfnProgress, probar))
	//	{
	//		GDALClose((GDALDatasetH)poSrcDS);
	//		GDALClose(poDstDs);
	//		delete poSpatialRef;
	//		poSpatialRef = NULL;
	//		return 0;
	//	}
	//}
	//else
	//{
	//	if (CE_None != GDALPolygonize(hSrcBand, NULL, (OGRLayerH)poLayer, 0, NULL, pfnProgress, probar))
	//	{
	//		GDALClose((GDALDatasetH)poSrcDS);
	//		GDALClose(poDstDs);
	//		delete poSpatialRef;
	//		poSpatialRef = NULL;
	//		return 0;
	//	}
	//}
	if (CE_None != GDALPolygonize(hSrcBand, hSrcBand, (OGRLayerH)poLayer, 0, NULL, pfnProgress, probar))
	{
		GDALClose((GDALDatasetH)poSrcDS);
		GDALClose(poDstDs);
		delete poSpatialRef;
		poSpatialRef = NULL;
		return 0;
	}

	GDALClose((GDALDatasetH)poSrcDS);
	GDALClose(poDstDs);
	poSpatialRef = NULL;

	return true;
}